Queuing stores operations in an ordered buffer and processes them individually. It is the primary Pacer strategy for work that should not be discarded when calls arrive faster than they can run.
Queues are lossless only while they have capacity. A finite maxSize, explicit clearing, expiration, or a processing error can still remove or reject work.
Queuing (process one item every 2 ticks)
Timeline: [1 second per tick]
Calls: ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️
Queue: [ABC] [BC] [BCDE] [DE] [E] []
Executed: ✅ ✅ ✅ ✅ ✅ ✅
[======================================================]
^ Accepted items remain queued until processed
[Items arrive] [Process steadily] [Empty]The queue can process automatically with a delay between items, or remain stopped for manual processing.
Choose queuing when:
Choose another utility when:
Use the queued state or value API when queue contents drive the UI. Use the instance API for ordering, capacity, expiration, pause, resume, flush, and manual processing.
import { createQueuedSignal } from '@tanstack/solid-pacer'
const [items, addItem, queue] = createQueuedSignal(
processJob,
{ wait: 500 },
(state) => ({
items: state.items,
isRunning: state.isRunning,
}),
)
addItem(nextJob())
console.log(items(), queue.state().isRunning)The focused snippets later in this guide use createQueuer and assume they run inside a Solid reactive owner.
Pass initialItems when work is already available at creation time. The queue applies its normal insertion and capacity rules, and automatic processing can begin immediately unless started: false is set.
Automatic processing uses addItemsTo to choose where new items enter and getItemsFrom to choose where items leave.
FIFO processes the oldest item first. This is the default.
const queuer = createQueuer(processItem, {
addItemsTo: 'back',
getItemsFrom: 'front',
started: false,
})
queuer.addItem(1)
queuer.addItem(2)
queuer.addItem(3)
queuer.start() // Processes 1, 2, 3.LIFO processes the newest item first.
const queuer = createQueuer(processItem, {
addItemsTo: 'back',
getItemsFrom: 'back',
started: false,
})
queuer.addItem(1)
queuer.addItem(2)
queuer.addItem(3)
queuer.start() // Processes 3, 2, 1.Provide getPriority to process higher numeric priorities first. Priority ordering takes precedence over front and back retrieval.
type Task = { name: string; priority: number }
const queuer = createQueuer<Task>(processTask, {
getPriority: (task) => task.priority,
started: false,
})
queuer.addItem({ name: 'low', priority: 1 })
queuer.addItem({ name: 'high', priority: 3 })
queuer.addItem({ name: 'medium', priority: 2 })
queuer.start() // Processes high, medium, low.Queues start automatically by default. The first accepted item processes immediately, then wait controls the delay before later items.
const queuer = createQueuer(processItem, {
wait: 1000,
})Set started: false to collect items before processing:
const queuer = createQueuer(processItem, { started: false })
queuer.addItem(1)
queuer.addItem(2)
queuer.start()
queuer.stop()stop() cancels the scheduled tick and retains queued items. start() resumes automatic processing.
For manual control:
Set maxSize to bound the number of waiting items. An item added to a full queue is rejected, addItem() returns false, and onReject runs.
const queuer = createQueuer(processItem, {
maxSize: 2,
started: false,
onReject: (item, queuer) => {
console.log('Rejected:', item)
console.log('Total rejections:', queuer.store.state.rejectionCount)
},
})
queuer.addItem(1) // true
queuer.addItem(2) // true
queuer.addItem(3) // falseThe active synchronous execution is not part of size; size counts items still waiting in the queue.
Use expirationDuration to remove items that have waited too long:
const queuer = createQueuer(processItem, {
expirationDuration: 5000,
onExpire: (item) => {
console.log('Expired:', item)
},
})Use getIsExpired for custom logic:
const queuer = createQueuer(processItem, {
getIsExpired: (item, addedAt) => Date.now() - addedAt > item.maxAge,
})Expiration is checked while the automatic processing loop runs. A stopped queue evaluates stale items when processing resumes.
flush() processes waiting items immediately without the configured delay. Pass a count to process only part of the queue.
queuer.flush() // Process all waiting items.
queuer.flush(2) // Process at most two waiting items.flushAsBatch() removes all waiting items and passes them to a separate batch function:
queuer.flushAsBatch((items) => {
saveItems(items)
})clear() removes all waiting items without processing them. It does not change whether the queue is running.
queuer.clear()reset() restores state to the default running, empty queue. It does not clear an already scheduled timeout. Call stop() before reset() when scheduled work must be canceled.
queuer.stop()
queuer.reset()Use setOptions() to update future behavior. Changing started through setOptions() does not call start() or stop().
queuer.setOptions({ wait: 250, maxSize: 20 })
queuer.start()The wait option may be a function that receives the queuer instance:
const queuer = createQueuer(processItem, {
wait: (queuer) => (queuer.store.state.size > 20 ? 50 : 250),
})Use callbacks for queue events:
The adapter stops automatic processing when its owner is destroyed. Providing onUnmount replaces that default cleanup, so a custom callback must perform every required lifecycle action. When custom cleanup flushes work, remember that user callbacks can run while the component is being destroyed.
The adapter subscribes only to the state returned by the selector argument. Without a selector, the adapter state is empty. Create the utility inside a Solid reactive owner and select only fields used by the view:
const queuer = createQueuer(processItem, { wait: 250 }, (state) => ({
size: state.size,
isRunning: state.isRunning,
}))
console.log(queuer.state().size, queuer.state().isRunning)Option functions and lifecycle callbacks receive the underlying public utility instance. The .store.state reads inside those callbacks in the examples above are supported. Rendering code should read the selected adapter state shown here.
initialState can restore selected queue state that your app has persisted. If it includes items, they take precedence over initialItems; initialState.isRunning likewise takes precedence over started. Restore only durable fields. Pending timers are not restored.
Commonly useful state includes:
See the Solid API reference for adapter signatures and the public core reference for complete option and state types.

Queuing stores operations in an ordered buffer and processes them individually. It is the primary Pacer strategy for work that should not be discarded when calls arrive faster than they can run.
Queues are lossless only while they have capacity. A finite maxSize, explicit clearing, expiration, or a processing error can still remove or reject work.
Queuing (process one item every 2 ticks)
Timeline: [1 second per tick]
Calls: ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️
Queue: [ABC] [BC] [BCDE] [DE] [E] []
Executed: ✅ ✅ ✅ ✅ ✅ ✅
[======================================================]
^ Accepted items remain queued until processed
[Items arrive] [Process steadily] [Empty]The queue can process automatically with a delay between items, or remain stopped for manual processing.
Choose queuing when:
Choose another utility when:
Use the queued state or value API when queue contents drive the UI. Use the instance API for ordering, capacity, expiration, pause, resume, flush, and manual processing.
Create the composable during component setup or in an active effect scope. Scope disposal runs its cleanup. The example imports application operations from ./api.
<script setup lang="ts">
import { useQueuer } from '@tanstack/vue-pacer'
import { processJob } from './api'
const queue = useQueuer(processJob, { wait: 500 }, (state) => ({
items: state.items,
isRunning: state.isRunning,
}))
const state = queue.state
</script>
<template>
<button @click="queue.addItem('task')">Add job</button>
<output>{{ state.items.length }}</output>
</template>The focused snippets below use useQueuer during setup, and instance methods from event handlers.
Pass initialItems when work is already available at creation time. The queue applies its normal insertion and capacity rules, and automatic processing can begin immediately unless started: false is set.
useQueuedState returns [itemsAccessor, addItem, queue]. Call itemsAccessor() to read pending items.
Automatic processing uses addItemsTo to choose where new items enter and getItemsFrom to choose where items leave.
FIFO processes the oldest item first. This is the default.
const queuer = useQueuer(processItem, {
addItemsTo: 'back',
getItemsFrom: 'front',
started: false,
})
queuer.addItem(1)
queuer.addItem(2)
queuer.addItem(3)
queuer.start() // Processes 1, 2, 3.LIFO processes the newest item first.
const queuer = useQueuer(processItem, {
addItemsTo: 'back',
getItemsFrom: 'back',
started: false,
})
queuer.addItem(1)
queuer.addItem(2)
queuer.addItem(3)
queuer.start() // Processes 3, 2, 1.Provide getPriority to process higher numeric priorities first. Priority ordering takes precedence over front and back retrieval.
type Task = { name: string; priority: number }
const queuer = useQueuer<Task>(processTask, {
getPriority: (task) => task.priority,
started: false,
})
queuer.addItem({ name: 'low', priority: 1 })
queuer.addItem({ name: 'high', priority: 3 })
queuer.addItem({ name: 'medium', priority: 2 })
queuer.start() // Processes high, medium, low.Queues start automatically by default. The first accepted item processes immediately, then wait controls the delay before later items.
const queuer = useQueuer(processItem, {
wait: 1000,
})Set started: false to collect items before processing:
const queuer = useQueuer(processItem, { started: false })
queuer.addItem(1)
queuer.addItem(2)
queuer.start()
queuer.stop()stop() cancels the scheduled tick and retains queued items. start() resumes automatic processing.
For manual control:
Set maxSize to bound the number of waiting items. An item added to a full queue is rejected, addItem() returns false, and onReject runs.
const queuer = useQueuer(processItem, {
maxSize: 2,
started: false,
onReject: (item, queuer) => {
console.log('Rejected:', item)
console.log('Total rejections:', queuer.store.state.rejectionCount)
},
})
queuer.addItem(1) // true
queuer.addItem(2) // true
queuer.addItem(3) // falseThe active synchronous execution is not part of size; size counts items still waiting in the queue.
Use expirationDuration to remove items that have waited too long:
const queuer = useQueuer(processItem, {
expirationDuration: 5000,
onExpire: (item) => {
console.log('Expired:', item)
},
})Use getIsExpired for custom logic:
const queuer = useQueuer(processItem, {
getIsExpired: (item, addedAt) => Date.now() - addedAt > item.maxAge,
})Expiration is checked while the automatic processing loop runs. A stopped queue evaluates stale items when processing resumes.
flush() processes waiting items immediately without the configured delay. Pass a count to process only part of the queue.
queuer.flush() // Process all waiting items.
queuer.flush(2) // Process at most two waiting items.flushAsBatch() removes all waiting items and passes them to a separate batch function:
queuer.flushAsBatch((items) => {
saveItems(items)
})clear() removes all waiting items without processing them. It does not change whether the queue is running.
queuer.clear()reset() restores state to the default running, empty queue. It does not clear an already scheduled timeout. Call stop() before reset() when scheduled work must be canceled.
queuer.stop()
queuer.reset()Use setOptions() to update future behavior. Changing started through setOptions() does not call start() or stop().
queuer.setOptions({ wait: 250, maxSize: 20 })
queuer.start()The wait option may be a function that receives the queuer instance:
const queuer = useQueuer(processItem, {
wait: (queuer) => (queuer.store.state.size > 20 ? 50 : 250),
})Use callbacks for queue events:
The adapter stops automatic processing when its owner is destroyed. Providing onUnmount replaces that default cleanup, so a custom callback must perform every required lifecycle action. When custom cleanup flushes work, remember that user callbacks can run while the component is being destroyed.
The adapter subscribes only to the state returned by the selector argument. Without a selector, the adapter state is empty. Read selected state through utility.state.value in JavaScript. Bind that ref in the template to keep the output reactive:
const queuer = useQueuer(processItem, { wait: 250 }, (state) => ({
size: state.size,
isRunning: state.isRunning,
}))
console.log(queuer.state.value.size, queuer.state.value.isRunning)Use utility.Subscribe with a selector and a scoped slot for an independently subscribed child.
Option functions and lifecycle callbacks receive the underlying public utility instance. The .store.state reads inside those callbacks in the examples above are supported. Rendering code should read the selected adapter state shown here.
initialState can restore selected queue state that your app has persisted. If it includes items, they take precedence over initialItems; initialState.isRunning likewise takes precedence over started. Restore only durable fields. Pending timers are not restored.
Commonly useful state includes:
See the Vue API reference for adapter signatures and the public core reference for complete option and state types.

Queuing stores operations in an ordered buffer and processes them individually. It is the primary Pacer strategy for work that should not be discarded when calls arrive faster than they can run.
Queues are lossless only while they have capacity. A finite maxSize, explicit clearing, expiration, or a processing error can still remove or reject work.
Queuing (process one item every 2 ticks)
Timeline: [1 second per tick]
Calls: ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️ ⬇️
Queue: [ABC] [BC] [BCDE] [DE] [E] []
Executed: ✅ ✅ ✅ ✅ ✅ ✅
[======================================================]
^ Accepted items remain queued until processed
[Items arrive] [Process steadily] [Empty]The queue can process automatically with a delay between items, or remain stopped for manual processing.
Choose queuing when:
Choose another utility when:
Use the queued state or value API when queue contents drive the UI. Use the instance API for ordering, capacity, expiration, pause, resume, flush, and manual processing.
import { useQueuedState } from '@tanstack/react-pacer'
function JobQueue() {
const [items, addItem, queue] = useQueuedState(
processJob,
{ wait: 500 },
(state) => ({
items: state.items,
isRunning: state.isRunning,
}),
)
return (
<>
<button onClick={() => addItem(nextJob())}>Add job</button>
<button
onClick={() => (queue.state.isRunning ? queue.stop() : queue.start())}
>
{queue.state.isRunning ? 'Pause' : 'Resume'} ({items.length})
</button>
</>
)
}The focused snippets later in this guide use useQueuer and assume they run inside a component or another hook.
Pass initialItems when work is already available at creation time. The queue applies its normal insertion and capacity rules, and automatic processing can begin immediately unless started: false is set.
Automatic processing uses addItemsTo to choose where new items enter and getItemsFrom to choose where items leave.
FIFO processes the oldest item first. This is the default.
const queuer = useQueuer(processItem, {
addItemsTo: 'back',
getItemsFrom: 'front',
started: false,
})
queuer.addItem(1)
queuer.addItem(2)
queuer.addItem(3)
queuer.start() // Processes 1, 2, 3.LIFO processes the newest item first.
const queuer = useQueuer(processItem, {
addItemsTo: 'back',
getItemsFrom: 'back',
started: false,
})
queuer.addItem(1)
queuer.addItem(2)
queuer.addItem(3)
queuer.start() // Processes 3, 2, 1.Provide getPriority to process higher numeric priorities first. Priority ordering takes precedence over front and back retrieval.
type Task = { name: string; priority: number }
const queuer = useQueuer<Task>(processTask, {
getPriority: (task) => task.priority,
started: false,
})
queuer.addItem({ name: 'low', priority: 1 })
queuer.addItem({ name: 'high', priority: 3 })
queuer.addItem({ name: 'medium', priority: 2 })
queuer.start() // Processes high, medium, low.Queues start automatically by default. The first accepted item processes immediately, then wait controls the delay before later items.
const queuer = useQueuer(processItem, {
wait: 1000,
})Set started: false to collect items before processing:
const queuer = useQueuer(processItem, { started: false })
queuer.addItem(1)
queuer.addItem(2)
queuer.start()
queuer.stop()stop() cancels the scheduled tick and retains queued items. start() resumes automatic processing.
For manual control:
Set maxSize to bound the number of waiting items. An item added to a full queue is rejected, addItem() returns false, and onReject runs.
const queuer = useQueuer(processItem, {
maxSize: 2,
started: false,
onReject: (item, queuer) => {
console.log('Rejected:', item)
console.log('Total rejections:', queuer.store.state.rejectionCount)
},
})
queuer.addItem(1) // true
queuer.addItem(2) // true
queuer.addItem(3) // falseThe active synchronous execution is not part of size; size counts items still waiting in the queue.
Use expirationDuration to remove items that have waited too long:
const queuer = useQueuer(processItem, {
expirationDuration: 5000,
onExpire: (item) => {
console.log('Expired:', item)
},
})Use getIsExpired for custom logic:
const queuer = useQueuer(processItem, {
getIsExpired: (item, addedAt) => Date.now() - addedAt > item.maxAge,
})Expiration is checked while the automatic processing loop runs. A stopped queue evaluates stale items when processing resumes.
flush() processes waiting items immediately without the configured delay. Pass a count to process only part of the queue.
queuer.flush() // Process all waiting items.
queuer.flush(2) // Process at most two waiting items.flushAsBatch() removes all waiting items and passes them to a separate batch function:
queuer.flushAsBatch((items) => {
saveItems(items)
})clear() removes all waiting items without processing them. It does not change whether the queue is running.
queuer.clear()reset() restores state to the default running, empty queue. It does not clear an already scheduled timeout. Call stop() before reset() when scheduled work must be canceled.
queuer.stop()
queuer.reset()Use setOptions() to update future behavior. Changing started through setOptions() does not call start() or stop().
queuer.setOptions({ wait: 250, maxSize: 20 })
queuer.start()The wait option may be a function that receives the queuer instance:
const queuer = useQueuer(processItem, {
wait: (queuer) => (queuer.store.state.size > 20 ? 50 : 250),
})Use callbacks for queue events:
The adapter stops automatic processing when its owner is destroyed. Providing onUnmount replaces that default cleanup, so a custom callback must perform every required lifecycle action. When custom cleanup flushes work, remember that user callbacks can run while the component is being destroyed.
The adapter subscribes only to the state returned by the selector argument. Without a selector, the adapter state is empty. Create the utility at the top level of a component or another hook and select only fields used by the view:
const queuer = useQueuer(processItem, { wait: 250 }, (state) => ({
size: state.size,
isRunning: state.isRunning,
}))
console.log(queuer.state.size, queuer.state.isRunning)Option functions and lifecycle callbacks receive the underlying public utility instance. The .store.state reads inside those callbacks in the examples above are supported. Rendering code should read the selected adapter state shown here.
initialState can restore selected queue state that your app has persisted. If it includes items, they take precedence over initialItems; initialState.isRunning likewise takes precedence over started. Restore only durable fields. Pending timers are not restored.
Commonly useful state includes:
See the React API reference for adapter signatures and the public core reference for complete option and state types.